"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var timers_1 = require("timers");
var _ = require("lodash");
var amqp = require("amqplib");
var debug = require("debug");
var Bluebird = require("bluebird");
var interface_1 = require("./interface");
var helper_1 = require("../helper");
Promise = Bluebird;
var log = debug('blackfyre:broker:amqp');
var eventLog = debug('blackfyre:broker:amqp:event');
var AMQPBroker = /** @class */ (function (_super) {
    __extends(AMQPBroker, _super);
    function AMQPBroker(options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this) || this;
        _this.isConnecting = false;
        _this.isProducerChannelCreating = false;
        _this.taskRegisterMap = {};
        _this.taskRegisterWaitQueue = [];
        _this.taskWaitQueue = [];
        _this.options = _.assign({
            url: 'amqp://localhost',
            queueSuffix: 'queue',
            exchangeName: 'worker-exchange',
            exchangeType: 'direct',
            queueOptions: {
                durable: true,
            },
            socketOptions: null,
            exchangeOptions: null,
        }, options);
        return _this;
    }
    AMQPBroker.prototype.createConnection = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var url, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        url = this.options.url;
                        _a = this;
                        return [4 /*yield*/, amqp.connect(url, this.options.socketOptions)];
                    case 1:
                        _a.connection = _b.sent();
                        this.connection.on('error', function (err) {
                            _this.emit('error', err);
                            eventLog("Connection error " + err + " stack: " + err.stack);
                        });
                        this.connection.on('close', function () {
                            _this.emit('close', 'connection');
                            eventLog('Connection close');
                            _this.connection = null;
                        });
                        return [2 /*return*/, this.connection];
                }
            });
        });
    };
    AMQPBroker.prototype.getConnection = function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.connection) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.drainQueue()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, this.connection];
                    case 2:
                        if (this.isConnecting)
                            return [2 /*return*/, null];
                        this.isConnecting = true;
                        _a.label = 3;
                    case 3:
                        _a.trys.push([3, 6, , 7]);
                        return [4 /*yield*/, this.createConnection()];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, this.drainQueue()];
                    case 5:
                        _a.sent();
                        return [3 /*break*/, 7];
                    case 6:
                        e_1 = _a.sent();
                        this.isConnecting = false;
                        this.emit('error', e_1);
                        return [2 /*return*/, null];
                    case 7:
                        this.isConnecting = false;
                        return [2 /*return*/, this.connection];
                }
            });
        });
    };
    AMQPBroker.prototype.createProducerChannel = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var channel;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        /* istanbul ignore if */
                        if (this.producerChannel)
                            return [2 /*return*/, this.producerChannel];
                        log('Created connection !!!');
                        return [4 /*yield*/, this.connection.createConfirmChannel()];
                    case 1:
                        channel = _a.sent();
                        channel.on('error', function (err) {
                            _this.emit('error', err);
                            eventLog("Channel error " + err + " stack: " + err.stack);
                        });
                        channel.on('close', function () {
                            _this.emit('close', 'channel');
                            eventLog('Channel close');
                            _this.producerChannel = null;
                        });
                        log('Created channel !!!');
                        return [4 /*yield*/, channel.assertExchange(this.options.exchangeName, this.options.exchangeType, this.options.exchangeOptions)];
                    case 2:
                        _a.sent();
                        this.producerChannel = channel;
                        this.emit('channel-created', channel);
                        return [2 /*return*/, channel];
                }
            });
        });
    };
    AMQPBroker.prototype.createConsumerChannel = function (register) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var taskMeta, prefetchSize, channel, queueOptions;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        /* istanbul ignore if */
                        if (register.channel)
                            return [2 /*return*/, register.channel];
                        taskMeta = register.taskMeta;
                        prefetchSize = taskMeta.concurrency;
                        log('Begin create channel');
                        return [4 /*yield*/, this.connection.createChannel()];
                    case 1:
                        channel = _a.sent();
                        channel.on('error', function (err) {
                            _this.emit('error', err);
                            eventLog("Channel error " + err + " stack: " + err.stack);
                        });
                        channel.on('close', function () {
                            _this.emit('close', 'channel');
                            eventLog('Channel close');
                            register.channel = null;
                        });
                        return [4 /*yield*/, channel.assertExchange(this.options.exchangeName, this.options.exchangeType, this.options.exchangeOptions)];
                    case 2:
                        _a.sent();
                        queueOptions = _.clone(this.options.queueOptions);
                        if (taskMeta.maxPriority) {
                            queueOptions.maxPriority = taskMeta.maxPriority;
                        }
                        return [4 /*yield*/, Promise
                                .all([
                                channel.assertQueue(register.queueName, queueOptions),
                                channel.bindQueue(register.queueName, this.options.exchangeName, taskMeta.name),
                                channel.prefetch(prefetchSize),
                            ])];
                    case 3:
                        _a.sent();
                        log('Got channel');
                        register.channel = channel;
                        this.emit('channel-created', channel);
                        return [2 /*return*/, channel];
                }
            });
        });
    };
    AMQPBroker.prototype.getProducerChannel = function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        /* istanbul ignore if */
                        if (this.producerChannel)
                            return [2 /*return*/, this.producerChannel];
                        if (this.isProducerChannelCreating)
                            return [2 /*return*/, null];
                        this.isProducerChannelCreating = true;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.createProducerChannel()];
                    case 2:
                        _a.sent();
                        eventLog('Producer ready');
                        this.emit('ready');
                        return [3 /*break*/, 4];
                    case 3:
                        e_2 = _a.sent();
                        this.isProducerChannelCreating = false;
                        this.emit('error', e_2);
                        return [2 /*return*/];
                    case 4:
                        this.isProducerChannelCreating = false;
                        return [2 /*return*/, this.producerChannel];
                }
            });
        });
    };
    AMQPBroker.prototype.drainQueue = function () {
        return __awaiter(this, void 0, void 0, function () {
            var taskRegister, func;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        log('TaskRegister Queue size %d', this.taskRegisterWaitQueue.length);
                        _a.label = 1;
                    case 1:
                        if (!this.taskRegisterWaitQueue.length) return [3 /*break*/, 3];
                        taskRegister = this.taskRegisterWaitQueue.pop();
                        return [4 /*yield*/, this.createChannelAndConsume(taskRegister)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 1];
                    case 3:
                        log('Task queue size %d', this.taskWaitQueue.length);
                        if (!this.taskWaitQueue.length) return [3 /*break*/, 7];
                        return [4 /*yield*/, this.getProducerChannel()];
                    case 4:
                        _a.sent();
                        if (!this.producerChannel)
                            return [2 /*return*/];
                        _a.label = 5;
                    case 5:
                        if (!this.taskWaitQueue.length) return [3 /*break*/, 7];
                        func = this.taskWaitQueue.pop();
                        return [4 /*yield*/, func()];
                    case 6:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    AMQPBroker.prototype.checkConsumerConnection = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.map(_.values(this.taskRegisterMap), function (taskRegister) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                if (taskRegister.channel)
                                    return [2 /*return*/];
                                this.taskRegisterWaitQueue.push(taskRegister);
                                return [2 /*return*/];
                            });
                        }); })];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.getConnection()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    AMQPBroker.prototype.createChannelAndConsume = function (taskRegister) {
        return __awaiter(this, void 0, void 0, function () {
            var e_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        log('Create channel and consume %s', taskRegister.taskMeta.name);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 4, , 5]);
                        return [4 /*yield*/, this.createConsumerChannel(taskRegister)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.consume(taskRegister)];
                    case 3:
                        _a.sent();
                        eventLog('Consumer ready %s', taskRegister.taskMeta.name);
                        this.emit('ready', taskRegister.taskMeta.name);
                        return [3 /*break*/, 5];
                    case 4:
                        e_3 = _a.sent();
                        this.emit('error', e_3);
                        return [2 /*return*/];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    AMQPBroker.prototype.retryTask = function (task) {
        return __awaiter(this, void 0, void 0, function () {
            var taskRegister, delayMs, delayQueue, queueDaclareOptions;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        taskRegister = this.taskRegisterMap[task.name];
                        if (task.retryCount >= task.maxRetry) {
                            return [2 /*return*/, Promise.resolve(0)];
                        }
                        delayMs = helper_1.getRetryDelayMs(task);
                        // Increase retry count
                        task.retryCount += 1;
                        delayQueue = helper_1.getDelayQueue(delayMs, this.options.exchangeName, task.name);
                        queueDaclareOptions = helper_1.getDelayQueueOptions(delayMs, this.options.exchangeName, task.name);
                        return [4 /*yield*/, taskRegister.channel.assertQueue(delayQueue, queueDaclareOptions)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, taskRegister.channel.sendToQueue(delayQueue, new Buffer(JSON.stringify(task)), {
                                persistent: true,
                            })];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, task.maxRetry - task.retryCount];
                }
            });
        });
    };
    AMQPBroker.prototype.consume = function (taskRegister) {
        return __awaiter(this, void 0, void 0, function () {
            function processFuncWrap(msg) {
                return __awaiter(this, void 0, void 0, function () {
                    var task, result, e_4;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                /* istanbul ignore if */
                                if (msg === null)
                                    return [2 /*return*/];
                                try {
                                    task = JSON.parse(msg.content.toString());
                                }
                                catch (e) {
                                    channel.ack(msg);
                                    that.emit('error', e);
                                    return [2 /*return*/];
                                }
                                _a.label = 1;
                            case 1:
                                _a.trys.push([1, 3, , 6]);
                                return [4 /*yield*/, taskRegister.processFunc(task.body, task)];
                            case 2:
                                result = _a.sent();
                                return [3 /*break*/, 6];
                            case 3:
                                e_4 = _a.sent();
                                if (!!e_4.noRetry) return [3 /*break*/, 5];
                                return [4 /*yield*/, that.retryTask(task)];
                            case 4:
                                _a.sent();
                                _a.label = 5;
                            case 5: return [3 /*break*/, 6];
                            case 6:
                                channel.ack(msg);
                                return [2 /*return*/];
                        }
                    });
                });
            }
            var channel, that, consumerTag;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        channel = taskRegister.channel;
                        that = this;
                        log('consume %s', taskRegister.queueName);
                        return [4 /*yield*/, taskRegister.channel.consume(taskRegister.queueName, processFuncWrap, {
                                noAck: false,
                            })];
                    case 1:
                        consumerTag = (_a.sent()).consumerTag;
                        taskRegister.consumerTag = consumerTag;
                        return [2 /*return*/];
                }
            });
        });
    };
    AMQPBroker.prototype.send = function (task) {
        return __awaiter(this, void 0, void 0, function () {
            var ch, data, exchangeName, routingKey, publishOptions, delayMs, delayQueue, queueDaclareOptions;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ch = this.producerChannel;
                        data = JSON.stringify(task);
                        exchangeName = this.options.exchangeName;
                        routingKey = task.name;
                        publishOptions = {
                            persistent: true,
                            priority: task.priority,
                        };
                        if (!(task.eta && task.eta > Date.now())) return [3 /*break*/, 2];
                        delayMs = task.eta - Date.now();
                        delayQueue = helper_1.getDelayQueue(delayMs, exchangeName, routingKey);
                        queueDaclareOptions = helper_1.getDelayQueueOptions(delayMs, exchangeName, routingKey);
                        return [4 /*yield*/, ch.assertQueue(delayQueue, queueDaclareOptions)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, ch.sendToQueue(delayQueue, new Buffer(data), publishOptions)];
                    case 2: return [2 /*return*/, new Promise(function (resolve, reject) {
                            return ch.publish(exchangeName, routingKey, new Buffer(data), publishOptions, function (err, ok) {
                                /* istanbul ignore if */
                                if (err)
                                    return reject(err);
                                return resolve(ok);
                            });
                        })];
                }
            });
        });
    };
    AMQPBroker.prototype.registerTask = function (taskMeta, processFunc) {
        return __awaiter(this, void 0, void 0, function () {
            var taskRegister;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        taskRegister = {
                            taskMeta: taskMeta,
                            processFunc: processFunc,
                            queueName: taskMeta.name + "_" + this.options.queueSuffix,
                        };
                        this.taskRegisterMap[taskMeta.name] = taskRegister;
                        this.taskRegisterWaitQueue.push(taskRegister);
                        return [4 /*yield*/, this.getConnection()];
                    case 1:
                        _a.sent();
                        if (!this.checkJob) {
                            this.checkJob = timers_1.setInterval(this.checkConsumerConnection.bind(this), 500);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    AMQPBroker.prototype.publish = function (task) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var p;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        p = new Promise(function (resolve, reject) {
                            log('task %s pushed to wait queue', task.name);
                            _this.taskWaitQueue.push(function () {
                                return _this.send(task).then(resolve, reject);
                            });
                        });
                        return [4 /*yield*/, this.getConnection()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, p];
                }
            });
        });
    };
    AMQPBroker.prototype.checkHealth = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, Promise.props({
                        consumer: Promise.map(_.values(this.taskRegisterMap), function (taskRegister) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                if (taskRegister.channel && taskRegister.queueName) {
                                    return [2 /*return*/, taskRegister.channel.checkQueue(taskRegister.queueName)];
                                }
                                return [2 /*return*/, []];
                            });
                        }); }),
                        producer: this.producerChannel && this.producerChannel.checkExchange(this.options.exchangeName),
                    })];
            });
        });
    };
    AMQPBroker.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.connection) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.connection.close()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    return AMQPBroker;
}(interface_1.Broker));
exports.AMQPBroker = AMQPBroker;
//# sourceMappingURL=amqp.js.map